#include <avr/io.h>

#include "Arduino.h"
#include "config.h"
#include "def.h"
#include "types.h"
#include "MultiWii.h"
#include "Alarms.h"
#include "EEPROM.h"
#include "IMU.h"
#include "LCD.h"
#include "Output.h"
#include "RX.h"
#include "Sensors.h"
#include "Serial.h"
#include "GPS.h"
#include "Protocol.h"

#include "EQ.h"
#include "ULN2003.h"

#include "Config.Classic.h"
#include "FPoint.h"
#include "Globals.h"
#include "Command.h"

#include <avr/pgmspace.h>

// uint32_t ONE_STEP = 134631; // 1/32
// uint32_t ONE_STEP = 21118652; // 35BYJ412
// uint32_t ONE_STEP = 11219284; // 35PM412 8拍半步驱动
// uint32_t ONE_STEP = 22438568; // 35PM412 4拍整步驱动
// uint32_t ONE_STEP = 5983618; // 35PM412 同步轮减速 80 * 60 / 16 = 300
// uint32_t ONE_STEP = 373976; // 35PM412 1:60 减速 80 * 60 = 4800
uint32_t ONE_STEP = 186988; // 35PM412 1:60 减速 80 * 60 = 4800 Half Step
uint32_t nOldMicro = 0, nNewMicro = 0;

void setup()
{
    EQInit();
 
    // Open serial port.
    SerialOpen(0,SERIAL0_COM_SPEED);
    
    nOldMicro = micros();
    nNewMicro = nOldMicro;
}

void loop()
{
  serialComTelescope();
  processCommands();    // LX200
  
  nNewMicro = micros();
  
  if ((nNewMicro - nOldMicro) > (ONE_STEP * 1))
  {
    unsigned long nLonStep = (nNewMicro - nOldMicro) / ONE_STEP;
    nOldMicro += nLonStep * ONE_STEP;
    
    AutoTrace(nLonStep);
  }
  
  PhotoLoop();
  EQLoop();  
}
